﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading;
using System.Windows;
using System.Windows.Forms;


namespace ZKIDCardReader
{
    public partial class Form1 : Form
    {
        const int MSG_CARD_READY = 0x0400 + 6;

        [DllImport("termb.dll")]
        public extern static int InitComm(int Port);
        [DllImport("termb.dll")]
        public extern static int InitCommExt();
        [DllImport("termb.dll")]
        public extern static int Authenticate();
        [DllImport("termb.dll")]
        public extern static int Read_Content(int Active);
        [DllImport("termb.dll")]
        unsafe public extern static int Read_Content_Path(string strPath, int Active);
        [DllImport("termb.dll")]
        unsafe public extern static int CloseComm();
        [DllImport("termb.dll")]
        unsafe public extern static int GetBmpPhoto(string Wlt_File);
        [DllImport("user32.dll", EntryPoint = "SendMessageA")]
        public static extern int SendMessage(IntPtr hwnd, int wMsg, IntPtr wParam, IntPtr lParam);

        private volatile bool bTimeToStop;
        private Thread workThread;
        private IntPtr formHandle = IntPtr.Zero;

        private int m_nClickedBtnIndex = -1;
        private bool bCloseClicked;
        private bool bMinClicked;
        private bool formMove = false;//窗体是否移动
        private Point formPoint;//记录窗体的位置
        private bool m_bStop = true;
        private string m_strCardNo;
        private string m_strPath;
        private byte[] m_byLeftFinger = new byte[512];
        private byte[] m_byRightFinger = new byte[512];
        private int m_nLeftFinger = 0;
        private int m_nRightFinger = 0;
        private void pbTitle_MouseDown(object sender, MouseEventArgs e)//鼠标按下
        {
            formPoint = new Point();
            int xOffset;
            int yOffset;
            if (e.Button == MouseButtons.Left)
            {
                xOffset = -e.X;
                yOffset = -e.Y;
                formPoint = new Point(xOffset, yOffset);
                formMove = true;//开始移动
            }
        }
        private void pbTitle_MouseMove(object sender, MouseEventArgs e)//鼠标移动
        {
            if (formMove == true)
            {
                Point mousePos = Control.MousePosition;
                mousePos.Offset(formPoint.X, formPoint.Y);
                this.Location = mousePos;
            }
        }
        private void pbTitle_MouseUp(object sender, MouseEventArgs e)//鼠标松开
        {
            if (e.Button == MouseButtons.Left)//按下的是鼠标左键
            {
                formMove = false;//停止移动
            }
        }

        private void pbMin_Click(object sender, EventArgs e)
        {
            this.WindowState = FormWindowState.Minimized;//最小化
            bMinClicked = true;
        }

        private void pbClose_Click(object sender, EventArgs e)
        {
            bCloseClicked = true;
            Application.Exit();
        }

        public Form1()
        {
            InitializeComponent();
            formHandle = this.Handle;
            this.BackColor = Color.FromArgb(24, 52, 115);
            bTimeToStop = true;

            pbStart.Image = imageList1.Images[0];
            pbStop.Image = imageList1.Images[2];
            pbExit.Image = imageList1.Images[4];
            pbMin.Image = imageList2.Images[0];
            pbClose.Image = imageList2.Images[2];

            this.labelName.Parent = this.pictureBox3;
            this.labelGender.Parent = this.pictureBox3;
            this.labelBirthdate.Parent = this.pictureBox3;
            this.labelNationality.Parent = this.pictureBox3;
            this.labelOrg.Parent = this.pictureBox3;
            this.labelAddress.Parent = this.pictureBox3;
            this.labelIDNumber.Parent = this.pictureBox3;
            this.labelPeriod.Parent = this.pictureBox3;
            this.labelNewAddress.Parent = this.pictureBox3;

            labelSoftwareName.Parent = pbTitle;
            labelSoftwareName.Text = "第二代居民身份证阅读器";

            labelDate.Parent = pbBottom;
            DateTime dt = System.DateTime.Now;
            labelDate.Text = dt.ToString("yyyy-MM-dd");
            labelInfo.Parent = pbBottom;
            labelInfo.ForeColor = Color.FromArgb(255, 223, 0);
            startReadCard();
            m_bStop = true;
            m_strPath = Application.StartupPath; 
        }

        
        private void ThreadWorkFunction()
        {
            int ret;
            while (!bTimeToStop)
            {
                Thread.Sleep(500);
                ret = Authenticate();//卡认证
                if (1 == ret)
                {       
                    SendMessage(formHandle, MSG_CARD_READY, IntPtr.Zero, IntPtr.Zero);
                }
            }
            return;      
        }

        protected override void DefWndProc(ref Message m)
        {
            switch (m.Msg)
            {
                case MSG_CARD_READY:
                    {
                        try
                        {
                            this.labelIDNumber.Text = "";
                            this.labelName.Text = "";
                            this.labelGender.Text = "";
                            this.labelNationality.Text = "";
                            this.labelBirthdate.Text = "";
                            this.labelAddress.Text = "";
                            this.labelOrg.Text = "";
                            this.labelPeriod.Text = "";
                            this.labelNewAddress.Text = "";
                            this.picboxPhoto.Image = null;
                            this.labelInfo.Text = @"正在读卡";
                            int r;
                            r = Read_Content(1);//读卡
                            if (r <= 0)
                            {
                                this.labelInfo.Text = @"读卡失败";
                                return;
                            }
                            string filename = m_strPath + @"\\xp.wlt";
                            if (1 == GetBmpPhoto(filename))
                            {
                                string strName;
                                string strSex;
                                string strNation;
                                string strBirthY;
                                string strBirthM;
                                string strBirthD;
                                string strAddress;
                                string strNewAddress;
                                string strID;
                                string strOrg;
                                string strVaildity;
                                string strTemp;
                                m_nLeftFinger = 0;
                                m_byLeftFinger.Initialize();
                                m_nRightFinger = 0;
                                m_byRightFinger.Initialize();


                                filename = m_strPath + @"\\zp.bmp";
                                Image image = Image.FromFile(filename);
                                Image tmpImage = new Bitmap(image);
                                this.picboxPhoto.Image = tmpImage;
                                image.Dispose();

                                
                                FileStream fs = new FileStream(filename, FileMode.Open);
                                BinaryReader br = new BinaryReader(fs);
                                int nCount = (int)fs.Length;
                                byte[] bmpInfo = new byte[nCount];
                                bmpInfo = br.ReadBytes(nCount);
                             
                                br.Close();
                                fs.Close();

                                filename = m_strPath + @"\\wz.txt";
                                fs = new FileStream(filename, FileMode.Open);
                                StreamReader sr = new StreamReader(fs, System.Text.Encoding.Unicode);
                                string filecontent = sr.ReadToEnd();
                                sr.Close();
                                fs.Close();

                                //解析身份证指纹

                                strName = filecontent.Substring(0, 15);//name
                                strTemp = filecontent.Substring(15, 1);//gender
                                if (@"1" == strTemp)
                                    strSex = @"男";
                                else
                                    strSex = @"女";

                                strTemp = filecontent.Substring(16, 2);//nationality
                                int i = Convert.ToInt32(strTemp);
                                strNation = getNation(i);

                                strTemp = filecontent.Substring(18, 8);//birthdate
                                strBirthY = strTemp.Substring(0, 4);
                                strBirthM = strTemp.Substring(4, 2);
                                strBirthD = strTemp.Substring(6, 2);
                                strAddress = filecontent.Substring(26, 35);//address
                                strID = filecontent.Substring(61, 18);//IDNumber                     

                                m_strCardNo = strID;
                                strOrg = filecontent.Substring(79, 15);//org
                                strTemp = filecontent.Substring(94, 16);//period
                                strVaildity = strTemp.Substring(0, 4) + @"." + strTemp.Substring(4, 2) + @"." + strTemp.Substring(6, 2) + @" - " +
                                              strTemp.Substring(8, 4) + @"." + strTemp.Substring(12, 2) + @"." + strTemp.Substring(14, 2);
                                strNewAddress = "";
                                this.labelIDNumber.Text = strID;
                                this.labelName.Text = strName;
                                this.labelGender.Text = strSex;
                                this.labelNationality.Text = strNation;
                                this.labelBirthdate.Text = strBirthY + @"年" + strBirthM + @"月" + strBirthD + @"日";
                                this.labelAddress.Text = strAddress;
                                this.labelOrg.Text = strOrg;
                                this.labelPeriod.Text = strVaildity;
                                this.labelNewAddress.Text = strNewAddress;
                                this.labelInfo.Text = @"读卡成功，请放入下一张卡";
                            }
                            else
                            {
                                this.labelInfo.Text = @"读卡失败，请重试";
                            }
                        }
                        catch (System.Exception ex)
                        {
                            MessageBox.Show(ex.Message.ToString());
                        }
                    }
                    break;
                default:
                    base.DefWndProc(ref m);
                    break;    
            }
            
        }
        /*
        public BitmapImage ByteArrayToBitmapImage(byte[] byteArray)
        {
            BitmapImage bmp = null;
            try
            {
                bmp = new BitmapImage();
                bmp.BeginInit();
                bmp.StreamSource = new MemoryStream(byteArray);
                bmp.EndInit();
            }
            catch
            {
                bmp = null;
            }

            return bmp;
        }
         */

        private void startReadCard()
        {
            int port = 1;
            if (!m_bStop)
            {
                return;
            }

            port = InitCommExt();//初始化
            if (0 == port)
            {
                labelInfo.Text = "连接读卡器失败";
                pbBottom.Invalidate();
                return;
            }
            else
            {
                bTimeToStop = false;
                labelInfo.Text = "请放卡...";
                pbBottom.Invalidate();
            }
            m_nClickedBtnIndex = 0;
            workThread = new Thread(new ThreadStart(ThreadWorkFunction));
            workThread.IsBackground = true;
            workThread.Start();
            m_bStop = false;
            pbStart.Image = imageList1.Images[1];
            return;
        }

        private void pbStart_Click(object sender, EventArgs e)
        {
            startReadCard();
        }
        private void pbStart_MouseDown(object sender, MouseEventArgs e)
        {
            pbStart.Image = imageList1.Images[1];
            pbStop.Image = imageList1.Images[2];
            pbExit.Image = imageList1.Images[4];
        }
        private void pbStart_MouseEnter(object sender, EventArgs e)
        {
            pbStart.Image = imageList1.Images[1];
        }
        private void pbStart_MouseLeave(object sender, EventArgs e)
        {
            if (0 != m_nClickedBtnIndex)
                pbStart.Image = imageList1.Images[0];
        }

        private void pbStop_Click(object sender, EventArgs e)
        {
            int ret;
            m_nClickedBtnIndex = 2;
            labelInfo.Text = "连接已断开";
            pbBottom.Invalidate();
   
            if (!bTimeToStop)
            {
                bTimeToStop = true;
                workThread.Join();
                ret = CloseComm();//关闭
                m_bStop = true;
            }
            return;
        }
        private void pbStop_MouseDown(object sender, MouseEventArgs e)
        {
            pbStart.Image = imageList1.Images[0];
            pbStop.Image = imageList1.Images[3];
            pbExit.Image = imageList1.Images[4];
        }
        private void pbStop_MouseEnter(object sender, EventArgs e)
        {
            pbStop.Image = imageList1.Images[3];
        }
        private void pbStop_MouseLeave(object sender, EventArgs e)
        {
            if (2 != m_nClickedBtnIndex)
                pbStop.Image = imageList1.Images[2];
        }

        private void pbExit_Click(object sender, EventArgs e)
        {
            if (!bTimeToStop)
            {
                bTimeToStop = true;
                workThread.Join();
                CloseComm();//关闭
            }

            m_nClickedBtnIndex = 3;
            Application.Exit();
        }
        private void pbExit_MouseDown(object sender, MouseEventArgs e)
        {
            pbStart.Image = imageList1.Images[0];
            pbStop.Image = imageList1.Images[2];
            pbExit.Image = imageList1.Images[5];
        }
        private void pbExit_MouseEnter(object sender, EventArgs e)
        {
            pbExit.Image = imageList1.Images[5];
        }
        private void pbExit_MouseLeave(object sender, EventArgs e)
        {
            if (3 == m_nClickedBtnIndex)
                pbExit.Image = imageList1.Images[4];
        }

        private void pictureBox3_Paint(object sender, PaintEventArgs e)
        {
            PictureBox pb = sender as PictureBox;
            foreach (Control C in pb.Controls)
            {
                if (C is Label)
                {
                    Label L = (Label)C;
                    L.Visible = false;
                    e.Graphics.DrawString(L.Text, L.Font, new SolidBrush(L.ForeColor), L.Left - pb.Left, L.Top - pb.Top);
                }
            }   
        }

        private void pbTitle_Paint(object sender, PaintEventArgs e)
        {
            PictureBox pb = sender as PictureBox;
            foreach (Control C in pb.Controls)
            {
                if (C is Label)
                {
                    Label L = (Label)C;
                    L.Visible = false;
                    e.Graphics.DrawString(L.Text, L.Font, new SolidBrush(L.ForeColor), L.Left - pb.Left, L.Top - pb.Top);
                }
            }
        }

        private void pbBottom_Paint(object sender, PaintEventArgs e)
        {
            PictureBox pb = sender as PictureBox;
            foreach (Control C in pb.Controls)
            {
                if (C is Label)
                {
                    Label L = (Label)C;
                    L.Visible = false;
                    e.Graphics.DrawString(L.Text, L.Font, new SolidBrush(L.ForeColor), L.Left - pb.Left, L.Top - pb.Top);
                }
            }
        }

        private void pbMin_MouseDown(object sender, MouseEventArgs e)
        {
            pbMin.Image = imageList2.Images[1];
        }
        private void pbMin_MouseUp(object sender, MouseEventArgs e)
        {
            pbMin.Image = imageList2.Images[0];
        }
        private void pbMin_MouseEnter(object sender, EventArgs e)
        {
            pbMin.Image = imageList2.Images[1];
        }
        private void pbMin_MouseLeave(object sender, EventArgs e)
        {
            if (!bMinClicked)
                pbMin.Image = imageList2.Images[0];
        }
        private void pbClose_MouseDown(object sender, MouseEventArgs e)
        {
            pbClose.Image = imageList2.Images[3];
        }
        private void pbClose_MouseUp(object sender, MouseEventArgs e)
        {
            pbClose.Image = imageList2.Images[2];
        }
        private void pbClose_MouseEnter(object sender, EventArgs e)
        {
            pbClose.Image = imageList2.Images[3];
        }
        private void pbClose_MouseLeave(object sender, EventArgs e)
        {
            if (!bCloseClicked)
                pbClose.Image = imageList2.Images[2];
        }


        private string getNation(int nNation)
        {
            string strText = "";
            switch (nNation)
            {
                case 01:
                    {
                        strText = @"汉";
                        break;
                    }
                case 02:
                    {
                        strText = @"蒙古";
                        break;
                    }
                case 03:
                    {
                        strText = @"回";
                        break;
                    }
                case 04:
                    {
                        strText = @"藏";
                        break;
                    }
                case 05:
                    {
                        strText = @"维吾尔";
                        break;
                    }
                case 06:
                    {
                        strText = @"苗";
                        break;
                    }
                case 07:
                    {
                        strText = @"彝";
                        break;
                    }
                case 08:
                    {
                        strText = @"壮";
                        break;
                    }
                case 09:
                    {
                        strText = @"布依";
                        break;
                    }
                case 10:
                    {
                        strText = @"朝鲜";
                        break;
                    }
                case 11:
                    {
                        strText = @"满";
                        break;
                    }
                case 12:
                    {
                        strText = @"侗";
                        break;
                    }
                case 13:
                    {
                        strText = @"瑶";
                        break;
                    }
                case 14:
                    {
                        strText = @"白";
                        break;
                    }
                case 15:
                    {
                        strText = @"土家";
                        break;
                    }
                case 16:
                    {
                        strText = @"哈尼";
                        break;
                    }
                case 17:
                    {
                        strText = @"哈萨克";
                        break;
                    }
                case 18:
                    {
                        strText = @"傣";
                        break;
                    }
                case 19:
                    {
                        strText = @"黎";
                        break;
                    }
                case 20:
                    {
                        strText = @"傈僳";
                        break;
                    }
                case 21:
                    {
                        strText = @"佤";
                        break;
                    }
                case 22:
                    {
                        strText = @"畲";
                        break;
                    }
                case 23:
                    {
                        strText = @"高山";
                        break;
                    }
                case 24:
                    {
                        strText = @"拉祜";
                        break;
                    }
                case 25:
                    {
                        strText = @"水";
                        break;
                    }
                case 26:
                    {
                        strText = @"东乡";
                        break;
                    }
                case 27:
                    {
                        strText = @"纳西";
                        break;
                    }
                case 28:
                    {
                        strText = @"景颇";
                        break;
                    }
                case 29:
                    {
                        strText = @"柯尔克孜";
                        break;
                    }
                case 30:
                    {
                        strText = @"土";
                        break;
                    }
                case 31:
                    {
                        strText = @"达斡尔";
                        break;
                    }
                case 32:
                    {
                        strText = @"仫佬";
                        break;
                    }
                case 33:
                    {
                        strText = @"羌";
                        break;
                    }
                case 34:
                    {
                        strText = @"布朗";
                        break;
                    }
                case 35:
                    {
                        strText = @"撒拉";
                        break;
                    }
                case 36:
                    {
                        strText = @"毛南";
                        break;
                    }
                case 37:
                    {
                        strText = @"仡佬";
                        break;
                    }
                case 38:
                    {
                        strText = @"锡伯";
                        break;
                    }
                case 39:
                    {
                        strText = @"阿昌";
                        break;
                    }
                case 40:
                    {
                        strText = @"普米";
                        break;
                    }
                case 41:
                    {
                        strText = @"塔吉克";
                        break;
                    }
                case 42:
                    {
                        strText = @"怒";
                        break;
                    }
                case 43:
                    {
                        strText = @"乌孜别克";
                        break;
                    }
                case 44:
                    {
                        strText = @"俄罗斯";
                        break;
                    }
                case 45:
                    {
                        strText = @"鄂温克";
                        break;
                    }
                case 46:
                    {
                        strText = @"德昂";
                        break;
                    }
                case 47:
                    {
                        strText = @"保安";
                        break;
                    }
                case 48:
                    {
                        strText = @"裕固";
                        break;
                    }
                case 49:
                    {
                        strText = @"京";
                        break;
                    }
                case 50:
                    {
                        strText = @"塔塔尔";
                        break;
                    }
                case 51:
                    {
                        strText = @"独龙";
                        break;
                    }
                case 52:
                    {
                        strText = @"鄂伦春";
                        break;
                    }
                case 53:
                    {
                        strText = @"赫哲";
                        break;
                    }
                case 54:
                    {
                        strText = @"门巴";
                        break;
                    }
                case 55:
                    {
                        strText = @"珞巴";
                        break;
                    }
                case 56:
                    {
                        strText = @"基诺";
                        break;
                    }
                default:
                    break;
            }
            return strText;
        }
    }
}
